#include "tap.h"
#include "ctype.h"

#define ID_START_CHANNEL    0x815c1c47

#define TAPNAME "StartCBeebies"

TAP_ID( ID_START_CHANNEL );
TAP_PROGRAM_NAME(TAPNAME);
TAP_AUTHOR_NAME("R2-D2");
TAP_DESCRIPTION("Startup on CBeebies between 6-10, 12-2 or 4-7");
TAP_ETCINFO(__DATE__);

dword TAP_EventHandler(word event, dword param1, dword param2)
{
  return param1;
}

int getLCN(char *filename)
{
  TYPE_File *file;
  dword buf = 0;
  char *buffer = (char*)&buf;
  int lcn, i;
  lcn = 0;
  if((file = TAP_Hdd_Fopen(filename)))
  {
    TAP_Hdd_Fread(buffer, 1, 3, file);
    TAP_Hdd_Fclose(file);

    // get LCN from text file
    for(i = 0; i < 3 && isdigit(buffer[i]); i++)
      lcn = lcn*10 + buffer[i]-'0';
  }
  return lcn;
}

int findChannel(int lcn, int *svcType, int *svcNum)
{
  int found = FALSE;
  if(lcn != 0)
  {
    // find channel from LCN
    TYPE_TapChInfo chInfo;
    int num[2], n, t;
    TAP_Channel_GetTotalNum(&num[0], &num[1]);
    for(t=0; t<2; t++)
    {
      for(n=0; !found && n<num[t]; n++)
      {
        if(TAP_Channel_GetInfo(t, n, &chInfo) && lcn == chInfo.logicalChNum)
        {
          found = TRUE;
          *svcType = t;
          *svcNum = n;
          break;
        }
      }
    }
  }
  return found;
}

void changeChannel(int lcn)
{
  int svcType, svcNum;
  if(findChannel(lcn, &svcType, &svcNum))
  {
    //TAP_ExitNormal();
//      TAP_Channel_Start( CHANNEL_Main, SVC_TYPE_Tv, channel );    // get current channel
    TAP_Channel_Start(CHANNEL_Main, svcType, svcNum);
    //__asm __volatile ("break 0\nnop\n");
    //TAP_EnterNormal();
  }
}

int TAP_Main(void)
{
  word mjd;
  byte hour, min, sec;
  TAP_GetTime(&mjd, &hour, &min, &sec);
  if((hour>=6 && hour<10) || (hour>=12 && hour<14) || (hour>=16 && hour<19))
  {
//  changeChannel(getLCN(TAPNAME ".txt"));
    changeChannel(71);
  }
  return 0;
}

